import java.lang.Math;

/*
 * TrigonometricFunctions.java
 * Author: Akio MIWA, 2001 summer.
 *  Permission to use, copy, modify and distribute without charge this
 * software, documentation, images, etc. is granted, provided that this 
 * comment and the author's name is retained.  The author assumes no 
 * responsibility for lost sleep as a consequence of use of this software.
 * 
 * 						Akio MIWA(triring)
 * 						akio@triring.net
 * ZɌ肳ꂽŁAOp֐邽߂̃NX
 * px(Pʂ́)^1000000{vZlԂB
 * RȂCl󂯕tȂB
 */

class TrigonometricFunctions extends Object {
   TrigonometricFunctions() {
   }

   long sin(int angle) {
      long signflag = 1;
      long result   = 0;
      if (angle < 0) {
         signflag = -1;
         angle = Math.abs(angle);
      }
      int a      = angle % 360;
      if ( a >=   0 && a <  90) result =  table[        a][0];
      if ( a >=  90 && a < 180) result =  table[180 -   a][0];
      if ( a >= 180 && a < 270) result = -table[  a - 180][0];
      if ( a >= 270 && a < 360) result = -table[360 -   a][0];
      return signflag * result;
   }


   long cos(int angle) {
      long signflag = 1;
      long result   = 0;
      if (angle < 0) {
      // signflag = -1;
         angle = Math.abs(angle);
      }
      int a      = angle % 360;
      if ( a >=   0 && a <  90) result =  table[        a][1];
      if ( a >=  90 && a < 180) result = -table[180 -   a][1];
      if ( a >= 180 && a < 270) result = -table[  a - 180][1];
      if ( a >= 270 && a < 360) result =  table[360 -   a][1];
      return result;
   // return signflag * result;
   }


   private static final long[][] table = {
      /*  sin  ,   cos   */
      {       0, 1000000 },  /*    0 degrees */
      {   17452,  999848 },  /*    1 degrees */
      {   34899,  999391 },  /*    2 degrees */
      {   52336,  998630 },  /*    3 degrees */
      {   69756,  997564 },  /*    4 degrees */
      {   87156,  996195 },  /*    5 degrees */
      {  104528,  994522 },  /*    6 degrees */
      {  121869,  992546 },  /*    7 degrees */
      {  139173,  990268 },  /*    8 degrees */
      {  156434,  987688 },  /*    9 degrees */
      {  173648,  984808 },  /*   10 degrees */
      {  190809,  981627 },  /*   11 degrees */
      {  207912,  978148 },  /*   12 degrees */
      {  224951,  974370 },  /*   13 degrees */
      {  241922,  970296 },  /*   14 degrees */
      {  258819,  965926 },  /*   15 degrees */
      {  275637,  961262 },  /*   16 degrees */
      {  292372,  956305 },  /*   17 degrees */
      {  309017,  951057 },  /*   18 degrees */
      {  325568,  945519 },  /*   19 degrees */
      {  342020,  939693 },  /*   20 degrees */
      {  358368,  933580 },  /*   21 degrees */
      {  374607,  927184 },  /*   22 degrees */
      {  390731,  920505 },  /*   23 degrees */
      {  406737,  913545 },  /*   24 degrees */
      {  422618,  906308 },  /*   25 degrees */
      {  438371,  898794 },  /*   26 degrees */
      {  453990,  891007 },  /*   27 degrees */
      {  469472,  882948 },  /*   28 degrees */
      {  484810,  874620 },  /*   29 degrees */
      {  500000,  866025 },  /*   30 degrees */
      {  515038,  857167 },  /*   31 degrees */
      {  529919,  848048 },  /*   32 degrees */
      {  544639,  838671 },  /*   33 degrees */
      {  559193,  829038 },  /*   34 degrees */
      {  573576,  819152 },  /*   35 degrees */
      {  587785,  809017 },  /*   36 degrees */
      {  601815,  798636 },  /*   37 degrees */
      {  615661,  788011 },  /*   38 degrees */
      {  629320,  777146 },  /*   39 degrees */
      {  642788,  766044 },  /*   40 degrees */
      {  656059,  754710 },  /*   41 degrees */
      {  669131,  743145 },  /*   42 degrees */
      {  681998,  731354 },  /*   43 degrees */
      {  694658,  719340 },  /*   44 degrees */
      {  707107,  707107 },  /*   45 degrees */
      {  719340,  694658 },  /*   46 degrees */
      {  731354,  681998 },  /*   47 degrees */
      {  743145,  669131 },  /*   48 degrees */
      {  754710,  656059 },  /*   49 degrees */
      {  766044,  642788 },  /*   50 degrees */
      {  777146,  629320 },  /*   51 degrees */
      {  788011,  615661 },  /*   52 degrees */
      {  798636,  601815 },  /*   53 degrees */
      {  809017,  587785 },  /*   54 degrees */
      {  819152,  573576 },  /*   55 degrees */
      {  829038,  559193 },  /*   56 degrees */
      {  838671,  544639 },  /*   57 degrees */
      {  848048,  529919 },  /*   58 degrees */
      {  857167,  515038 },  /*   59 degrees */
      {  866025,  500000 },  /*   60 degrees */
      {  874620,  484810 },  /*   61 degrees */
      {  882948,  469472 },  /*   62 degrees */
      {  891007,  453990 },  /*   63 degrees */
      {  898794,  438371 },  /*   64 degrees */
      {  906308,  422618 },  /*   65 degrees */
      {  913545,  406737 },  /*   66 degrees */
      {  920505,  390731 },  /*   67 degrees */
      {  927184,  374607 },  /*   68 degrees */
      {  933580,  358368 },  /*   69 degrees */
      {  939693,  342020 },  /*   70 degrees */
      {  945519,  325568 },  /*   71 degrees */
      {  951057,  309017 },  /*   72 degrees */
      {  956305,  292372 },  /*   73 degrees */
      {  961262,  275637 },  /*   74 degrees */
      {  965926,  258819 },  /*   75 degrees */
      {  970296,  241922 },  /*   76 degrees */
      {  974370,  224951 },  /*   77 degrees */
      {  978148,  207912 },  /*   78 degrees */
      {  981627,  190809 },  /*   79 degrees */
      {  984808,  173648 },  /*   80 degrees */
      {  987688,  156434 },  /*   81 degrees */
      {  990268,  139173 },  /*   82 degrees */
      {  992546,  121869 },  /*   83 degrees */
      {  994522,  104528 },  /*   84 degrees */
      {  996195,   87156 },  /*   85 degrees */
      {  997564,   69756 },  /*   86 degrees */
      {  998630,   52336 },  /*   87 degrees */
      {  999391,   34899 },  /*   88 degrees */
      {  999848,   17452 },  /*   89 degrees */
      { 1000000,       0 }   /*   90 degrees */
   };
}